diff --git a/CHANGELOG.md b/CHANGELOG.md
index 1e7edbf08b..e900f2587c 100644
--- a/CHANGELOG.md
+++ b/CHANGELOG.md
@@ -11,6 +11,7 @@ All notable changes to the Pony compiler and standard library will be documented
 - Back pressure notifications now given when encountered while sending data during `TCPConnection` pending writes
 - Improve efficiency of muted TCPConnection on non Windows platforms (PR #1477)
 - Compiler assertion failure during type checking
+- Runtime memory allocator bug on 32 bits systems
 
 ### Added
 
diff --git a/src/libponyrt/mem/pool.c b/src/libponyrt/mem/pool.c
index 413e437a53..614c329ba6 100644
--- a/src/libponyrt/mem/pool.c
+++ b/src/libponyrt/mem/pool.c
@@ -700,7 +700,14 @@ size_t ponyint_pool_index(size_t size)
   if(size > POOL_MAX)
     return POOL_COUNT;
 
-  return ((size_t)64 - __pony_clzl(size)) - POOL_MIN_BITS;
+  size_t bits;
+#ifdef ILP32
+  bits = 32;
+#else
+  bits = 64;
+#endif
+
+  return (bits - __pony_clzl(size)) - POOL_MIN_BITS;
 }
 
 size_t ponyint_pool_size(size_t index)
